"use strict";
/* eslint-disable @typescript-eslint/no-use-before-define */
/* eslint-disable class-methods-use-this */
/* eslint-disable import/prefer-default-export */
Object.defineProperty(exports, "__esModule", { value: true });
exports.GabbyAssetFactory = void 0;
var gabby_query_protocol_lib_1 = require("gabby-query-protocol-lib");
var gabby_query_protocol_projection_1 = require("gabby-query-protocol-projection");
var defaultOpLabels_1 = require("../defaultOpLabels");
exports.GabbyAssetFactory = {
    //
    fromJson: function (resourcesJson) {
        //
        var formulaEditorOptions = { newRootId: resourcesJson.newRootId };
        var formulaEditor;
        if (resourcesJson.predicateTreeJson) {
            formulaEditor = gabby_query_protocol_lib_1.PredicateFormulaEditorFactory.fromJson({
                predicateTreeJson: resourcesJson.predicateTreeJson,
                subjectDictionaryJson: resourcesJson.subjectDictionaryJson,
            }, formulaEditorOptions);
        }
        else {
            formulaEditor = gabby_query_protocol_lib_1.PredicateFormulaEditorFactory.fromEmpty(resourcesJson.subjectDictionaryJson, formulaEditorOptions);
            // I think maybe need to set root predicate?
        }
        var projectableSubjectJson = resourcesJson.projectableSubjectsJson ||
            makeProjectableSubject(formulaEditor.subjectDictionary);
        var projectionJson = resourcesJson.projectionJson || makeProjection(projectableSubjectJson);
        var projectionEditor = gabby_query_protocol_projection_1.ProjectionEditorFactory.fromJson({
            projectionItemsJson: projectionJson,
            projectableSubjectDictionaryJson: projectableSubjectJson,
        });
        return {
            predicateFormulaEditor: formulaEditor,
            projectionEditor: projectionEditor,
            operatorLabels: resourcesJson.operatorLabelsJson || defaultOpLabels_1.defaultOperatorLabels,
        };
    },
    toJson: function (gabbyAssets) {
        return {
            projection: gabbyAssets.projectionEditor.toJson(),
            predicateFormula: gabbyAssets.predicateFormulaEditor.toJson(),
        };
    },
};
var makeProjection = function (projectableJson) {
    //
    return Object.entries(projectableJson).map(function (_a, idx) {
        var subjectId = _a[0], projectionProps = _a[1];
        return {
            subjectId: subjectId,
            sortOrder: 1,
            columnOrder: idx,
            label: projectionProps.defaultLabel || subjectId,
        };
    });
};
var makeProjectableSubject = function (predicateSubjectDictionary) {
    var projectableSubject = {};
    predicateSubjectDictionary.getColumns().forEach(function (column) {
        projectableSubject[column.subjectId] = {
            isSortable: true,
            datatype: column.datatype,
            defaultLabel: column.defaultLabel,
        };
    });
    return projectableSubject;
};
//# sourceMappingURL=GabbyAssetFactory.js.map