"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GabbyQueryProtocolContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable import/no-extraneous-dependencies */
/* eslint-disable react/require-default-props */
var React = __importStar(require("react"));
var defaultOpLabels_1 = require("../../defaultOpLabels");
exports.GabbyQueryProtocolContext = React.createContext(null);
// eslint-disable-next-line @typescript-eslint/no-empty-function
var noop = function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
};
var GabbyQueryProtocolContextProvider = function (_a) {
    var children = _a.children, _b = _a.onChange, onChange = _b === void 0 ? noop : _b, projectionEditor = _a.projectionEditor, _c = _a.operatorLabels, operatorLabels = _c === void 0 ? defaultOpLabels_1.defaultOperatorLabels : _c, predicateFormulaEditor = _a.predicateFormulaEditor;
    //
    var _d = React.useState(
    // useState to make dependents 'aware' of change.
    // change/state is managed by predicateFormulaEditor
    predicateFormulaEditor.toJson().predicateTreeJson), _queryExpression = _d[0], setQueryExpression = _d[1];
    var _e = React.useState(projectionEditor.getProjectionOrderByColumPosition()), currentProjection = _e[0], setCurrentProjection = _e[1];
    // private (not exported)
    var updateProjectionState = function () {
        setCurrentProjection(projectionEditor.getProjectionOrderByColumPosition());
    };
    // private (not exported)
    var updateState = function (newState) {
        onChange(newState); // pretty sure this is for debug only
        setQueryExpression(newState);
    };
    var appendPredicate = function (parentNodeId, term) {
        var newPredicateId = predicateFormulaEditor.predicatesAppend(parentNodeId, term);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
        return newPredicateId;
    };
    var makeEmptyPredicate = function () {
        return predicateFormulaEditor.makeEmptyPredicate();
    };
    var getPredicateById = function (nodeId) {
        return predicateFormulaEditor.predicatesGetById(nodeId);
    };
    var getJunctionById = function (nodeId) {
        // should throw?
        return predicateFormulaEditor.predicatesGetJunctionById(nodeId);
    };
    var updatePredicate = function (nodeId, node) {
        predicateFormulaEditor.predicatesReplace(nodeId, node);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var removePredicate = function (nodeId) {
        predicateFormulaEditor.predicatesRemove(nodeId);
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var setDisjunction = function (predicateId) {
        predicateFormulaEditor.predicatesReplace(predicateId, {
            operator: "$or",
        });
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var setConjunction = function (predicateId) {
        predicateFormulaEditor.predicatesReplace(predicateId, {
            operator: "$and",
        });
        updateState(__assign({}, predicateFormulaEditor.toJson().predicateTreeJson));
    };
    var getChildrenIds = function (predicateId) {
        return predicateFormulaEditor.predicatesGetChildrenIds(predicateId);
    };
    // **************************************     projection
    var addProjectionItem = function (projectionSubject) {
        // TODO - tmc - I think keys will change I think the getByOrder...
        //        rekeys? the keys should remain the same but this will return {newKey:{sameKey:properties}}
        //        ** MAYBE, I THINK **
        var newProjectionKey = projectionEditor.addSubject(projectionSubject);
        updateProjectionState();
        return newProjectionKey;
    };
    var getProjectionItem = function (projectionKey) {
        return projectionEditor.getProjectionSubject(projectionKey);
    };
    var getOrderedProjectionList = function () {
        return currentProjection;
    };
    var removeProjectionItem = function (projectionKey) {
        projectionEditor.removeProjectionSubject(projectionKey);
        updateProjectionState();
    };
    var updateProjectionSubject = function (projectionKey, updateProps) {
        projectionEditor.updateSubject(projectionKey, updateProps);
        updateProjectionState();
    };
    // end projection
    var exportedProperties = {
        appendPredicate: appendPredicate,
        getChildrenIds: getChildrenIds,
        getPredicateById: getPredicateById,
        getJunctionById: getJunctionById,
        makeEmptyPredicate: makeEmptyPredicate,
        operatorLabels: operatorLabels,
        projectionEditor: projectionEditor,
        removePredicate: removePredicate,
        setConjunction: setConjunction,
        setDisjunction: setDisjunction,
        subjectDictionary: predicateFormulaEditor.subjectDictionary,
        updatePredicate: updatePredicate,
        // projection
        addProjectionItem: addProjectionItem,
        getOrderedProjectionList: getOrderedProjectionList,
        getProjectionItem: getProjectionItem,
        removeProjectionItem: removeProjectionItem,
        updateProjectionSubject: updateProjectionSubject,
    };
    return ((0, jsx_runtime_1.jsx)(exports.GabbyQueryProtocolContext.Provider, __assign({ value: exportedProperties }, { children: children }), void 0));
};
exports.default = GabbyQueryProtocolContextProvider;
//# sourceMappingURL=Provider.js.map